unit unGame;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls,
  Graphics, Dialogs, ExtCtrls, LCLtype;

type
  tiles = class(TImage)
    public
      wealth : integer;
      health : integer;
      assets : integer;
  end;

  players = class(TImage)
    public
      r : integer;
      c : integer;
      hp : integer;
      gold : integer;
      dmg : integer;
      //etc
  end;

  { TfrmGame }

  TfrmGame = class(TForm)
    scenery: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private

  public

  end;

var
  frmGame: TfrmGame;

implementation

{$R *.lfm}
Const
   offx = 10;
   offy = 10;

   //board dimensions
   rows = 20;
   cols = 24;

Var board  : array[1..rows, 1..cols] of tiles;
    player : players;

{ TfrmGame }

procedure TfrmGame.FormCreate(Sender: TObject);
var row, col : byte;
    thing : tiles;
begin
  randomize;

  //dynamically create the world
  for row := 1 to rows do
     for col := 1 to cols do
        begin
          //make a tile
          board[row,col] := tiles.create(self);
          board[row,col].parent := frmGame;

          //position it
          board[row,col].left := col*32;
          board[row,col].top := row*32;

          //feature it
          board[row,col].width := 32;
          board[row,col].height := 32;
          board[row,col].stretch := true;

          //decorate it
          scenery.GetBitmap(0,board[row,col].picture.bitmap);


        end;

  //make the player
  player := players.create(self);
  with player do
     begin
         parent := frmGame;
  		 //give starter stuff
  		 r := 1;
  		 c := 1;
         top := board[r,c].top;
         left := board[r,c].left;
         bringtofront
     end;
  scenery.GetBitmap(12,player.picture.bitmap);



end;

procedure TfrmGame.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //move the guy if possible
  case key of
  vk_up: //move up if possible


  end;



end;

end.

